/**
 * @file DllEditFunc.cpp
 * @brief ҏWn̊֐t@C
 * @author Shinji Watanabe
 * @verison 1.0
 * @date Jan.20.2008
 */

#include "ConvFactory.h"

//-----------------------------------------------------------------------------
/**
 * @brief Rs[s܂B
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2Copy(int nID)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	if (!pFooty->m_cDoc.IsSelecting())return FOOTY2ERR_NOTSELECTED;
	return pFooty->Copy() ? FOOTY2ERR_NONE : FOOTY2ERR_MEMORY;
}

//-----------------------------------------------------------------------------
/**
 * @brief ؂菈s܂B
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2Cut(int nID)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	if (!pFooty->m_cDoc.IsSelecting())return FOOTY2ERR_NOTSELECTED;
	return pFooty->Cut() ? FOOTY2ERR_NONE : FOOTY2ERR_MEMORY;
}

//-----------------------------------------------------------------------------
/**
 * @brief y[Xgs܂B
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2Paste(int nID)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	return pFooty->Paste() ? FOOTY2ERR_NONE : FOOTY2ERR_MEMORY;
}

//-----------------------------------------------------------------------------
/**
 * @brief ҏWĂ邩ǂ擾܂B
 * @param nID sFootyID
 */
FOOTYEXPORT(bool) Footy2IsEdited(int nID)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return false;
	return pFooty->m_cDoc.IsEdited();
}

//-----------------------------------------------------------------------------
/**
 * @brief SđIs܂
 * @param nID sFootyID
 * @param bRedraw ĕ`揈sǂ
 */
FOOTYEXPORT(int) Footy2SelectAll(int nID,bool bRedraw)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;

	// SđI
	pFooty->m_cDoc.SelectAll();

	// ĕ`揈
	if (bRedraw)
	{
		pFooty->m_cView[0].Refresh();
	}
	return FOOTY2ERR_NONE;
}


//-----------------------------------------------------------------------------
/**
 * @brief AhDs܂B
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2Undo(int id)
{
	// Footy擾
	CFooty *pFooty = GetFooty(id);
	if (!pFooty)return FOOTY2ERR_NOID;

	// I
	pFooty->m_cDoc.ClearSelected();

	// AhD
	if (!pFooty->Undo())
		return FOOTY2ERR_NOUNDO;

	// LbgʒuĐݒ
	for (int i=0;i<4;i++)
	{
		pFooty->m_cView[i].AdjustVisibleLine();
		pFooty->m_cView[i].AdjustVisiblePos();
	}

	// 
	return FOOTY2ERR_NONE;
}

//-----------------------------------------------------------------------------
/**
 * @brief hDs܂B
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2Redo(int id)
{
	// Footy擾
	CFooty *pFooty = GetFooty(id);
	if (!pFooty)return FOOTY2ERR_NOID;
	// I
	pFooty->m_cDoc.ClearSelected();
	// hD
	if (!pFooty->Redo())
		return FOOTY2ERR_NOUNDO;
	// 
	return FOOTY2ERR_NONE;
}


#ifndef UNDER_CE
//-----------------------------------------------------------------------------
/**
 * @brief s܂
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2SearchA(int nID,const char *szText,int nFlags)
{
	// ϊ
	CConvFactory cConv;
	if (!cConv.GetConv()->ToUnicode(szText,(size_t)strlen(szText)))
		return FOOTY2ERR_MEMORY;

	// 
	return Footy2SearchW(nID,reinterpret_cast<const wchar_t*>(cConv.GetConv()->GetConvData()),nFlags);
}
#endif	/*not defined UNDER_CE*/


//-----------------------------------------------------------------------------
/**
 * @brioef s܂
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2SearchW(int nID,const wchar_t *szText,int nFlags)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	
	// ̂Ƃ
	if (szText[0] == L'\0')
		return FOOTY2ERR_ARGUMENT;
	
	// s
	if (pFooty->m_cDoc.Search(szText,nFlags))			// Ƃ
	{
		if ((nFlags & SEARCH_NOT_ADJUST_VIEW) == 0)		// XN[
		{
			pFooty->m_cView[0].AdjustVisiblePos();
			pFooty->m_cView[0].AdjustVisibleLine();
		}
		if ((nFlags & SEARCH_NOT_REFRESH) == 0)			// ĕ`悳
		{
			pFooty->m_cView[0].Refresh();
		}
		return FOOTY2ERR_NONE;
	}
	else
	{
		// ȂƂ
		if ((nFlags & SEARCH_BEEP_ON_404) != 0)
			MessageBeep(MB_ICONEXCLAMATION);
		return FOOTY2ERR_404;
	}
}

//-----------------------------------------------------------------------------
/**
 * @brief VtgbNs
 * @param nID sFootyID
 */
FOOTYEXPORT(int) Footy2ShiftLock(int nID,bool bLocked)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;

	// VtgbNԂZbg
	for (int i=0;i<4;i++)
	{
		pFooty->m_cView[i].SetShiftLock(bLocked);
	}
	
	return FOOTY2ERR_NONE;
}

//-----------------------------------------------------------------------------
/**
 * @brief VtgbNĂ邩ǂ擾
 * @param nID sFootyID
 */
FOOTYEXPORT(bool) Footy2IsShiftLocked(int nID)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return false;
	// VtgbNԂ擾
	return pFooty->m_cView[0].IsShiftLocked();
}

//-----------------------------------------------------------------------------
/**
 * @brief ǂݍݐpǂݒ肵܂
 * @param	nID			[in] ݒΏFootyID
 * @param	bReadOnly	[in] ǂݍݐpǂ
 */
FOOTYEXPORT(int) Footy2SetReadOnly(int nID, bool bReadOnly)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return FOOTY2ERR_NOID;
	// ǂݍݐpǂݒ肵܂
	pFooty->m_cDoc.SetReadOnly( bReadOnly );
	return FOOTY2ERR_NONE;
}

//-----------------------------------------------------------------------------
/**
 * @brief ǂݍݐpǂ擾܂
 * @param	nID			[in] 擾ΏFootyID
 */
FOOTYEXPORT(bool) Footy2IsReadOnly(int nID)
{
	// Footy擾
	CFooty *pFooty = GetFooty(nID);
	if (!pFooty)return false;
	// ǂݍݐpǂ擾܂
	return pFooty->m_cDoc.IsReadOnly();
}

/*[EOF]*/
